<template>
  <div class="modal-backdrop">
    <div class="modal" style="width: 50%; height: 50%; margin: auto">
      <header class="modal-header">
        <slot name="header">
          <strong><h4>Ajout Nouveau Reviewer</h4></strong>
        </slot>
        <button type="button" class="btn-close" @click="close">
          <i class="las la-times-circle big-icon"></i>
        </button>
      </header>

      <section class="modal-body">
        <div class="m-5" v-if="isLoading">
          <fulfilling-bouncing-circle-spinner
            class="mx-auto"
            :animation-duration="2000"
            :size="60"
            :color="'#005C96'"
          />
        </div>
        <div v-else>
          <div class="alert alert-danger" v-if="errorMessage">
            {{ errorMessage }}
          </div>
          <form @submit="add" class="mt-5">
            <div class="form-group col-6 mx-auto" v-if="!oldReview">
              <label class="">Deadline</label>
              <input
                type="date"
                class="form-control"
                v-model="newReviewer.deadline"
                placeholder="Nom"
              />
            </div>
            <div class="form-group col-6 mx-auto">
              <label class="">Reviewer</label>
              <v-select
                :options="reviewers"
                :reduce="(item) => item.code"
                class="form-control-select"
                v-model="newReviewer.id"
                required
              >
              </v-select>
            </div>
            <div class="form-group col-sm-4 mx-auto mt-1">
              <input
                type="submit"
                class="btn btn-light btn-block"
                value="Valider"
              />
            </div>
          </form>
        </div>
      </section>

      <footer class="modal-footer">
        <!-- <slot name="footer"> This is the default footer! </slot> -->
        <button type="button" class="btn-green" @click="close">Fermer</button>
      </footer>
    </div>
  </div>
</template>



<script>
export default {
  name: "Modal",
  data() {
    return {
      newReviewer: {
        deadline: "",
        id: "",
      },
      submission: null,
      oldReview: false,
      review: null,
      reviewers: null,
      totalReviewers: 0,
      errorMessage: "",
      isLoading: false,
    };
  },
  mounted() {
    if (localStorage.getItem("submission")) {
      this.submission = JSON.parse(localStorage.getItem("submission"));
    }
    if (localStorage.getItem("review")) {
      this.oldReview = true;
      this.review = JSON.parse(localStorage.getItem("review"));
    }
    this.getReviewers();
  },
  methods: {
    addReviewer(e) {
      e.preventDefault();
      // console.log(this.newReviewer);
      this.errorMessage = "";
      this.isLoading = true;

      if (this.oldReview) {
        //if old review
        let tab = this.review.reviewers;
        console.log("tab: ", tab, "review", this.review)
        
        let findReviewer = false;

        tab.forEach((value, index) => {
            // console.log(index,value);
            if (value.reviewer === this.newReviewer.id){
              findReviewer = true; 
              this.isLoading = false;
              this.errorMessage = "Le reviewer est déjà ajouté pour cette soumission !!!"
              return;
            }  
        });

        console.log(" ============= findReviewer : ",findReviewer);
        if(findReviewer === false){
          tab.push({reviewer: this.newReviewer.id,})
          let datas = {
            reviewers: tab,
          };
          this.$service.update("reviews",this.review.id,datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            console.log("add reviewer data: ", data);
            this.isLoading = false;
            this.$swal.fire("Ajout réussie !", "", "success").then(() => {
              // this.close();
            });
          });
        }
      }else{
        //if new review
        let tab = [
          {
            reviewer: this.newReviewer.id,
          },
        ];
        let datas = {
          submission: this.submission.id,
          deadline: this.newReviewer.deadline,
          reviewers: tab,
        };
        this.$service.create("reviews", datas, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            return;
          }
          console.log("add reviewer data: ", data);
          this.isLoading = false;
          this.$swal.fire("Ajout réussie !", "", "success").then(() => {
            // this.close();
          });
        });
      }
    },
    getReviewers() {
      this.isLoading = true;
      this.errorMessage = "";
      let query = {
        options: {
          role: "reviewer",
        },
        sort: {Ò},
        page: 0,
        perPage: 100,
      };
      this.$service.listAdmins(query, (err, data) => {
        this.isLoading = false;
        if (err) {
          console.log(err);
          return;
        }
        if (data.admins) {
          console.log("list of reviewers: ", data.admins);
          this.errorMessage = "";
          this.reviewers = data.admins.map((admin) => {
            return {
              label:
                admin.firstname +
                " " +
                admin.lastname +
                " |   " +
                admin.profession,
              code: admin._id,
            };
          });
        }
      });
    },
    close() {
      this.$emit("close");
    },
  },
};
</script>



<style>
.modal-backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.3);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  background: #ffffff;
  box-shadow: 2px 2px 20px 1px;
  overflow-x: auto;
  display: flex;
  flex-direction: column;
}

.modal-header,
.modal-footer {
  padding: 15px;
  display: flex;
}

.modal-header {
  position: relative;
  border-bottom: 1px solid #eeeeee;
  color: #005c96;
  justify-content: space-between;
}

.modal-footer {
  border-top: 1px solid #eeeeee;
  flex-direction: column;
  justify-content: flex-end;
}

.modal-body {
  position: relative;
  padding: 20px 10px;
}

.btn-close {
  position: absolute;
  top: 0;
  right: 0;
  border: none;
  font-size: 20px;
  padding: 10px;
  cursor: pointer;
  font-weight: bold;
  color: #005c96;
  background: transparent;
}

.btn-green {
  color: white;
  background: #005c96;
  border: 1px solid #005c96;
  border-radius: 2px;
}
</style>
